Package org.apache.felix.http.base.internal.whiteboard

## Class SharedServletContextImpl

- java.lang.Object
- - org.apache.felix.http.base.internal.whiteboard.SharedServletContextImpl

All Implemented Interfaces:
  `javax.servlet.ServletContext`

    public class SharedServletContextImpl
    extends Object
    implements javax.servlet.ServletContext

This servlet context implementation represents the shared part for a servlet context backed by a servlet context helper. For each using bundle, a `PerBundleServletContextImpl` is created.

### Field Summary

### Fields inherited from interface javax.servlet.ServletContext

`ORDERED_LIBS, TEMPDIR`

### Constructor Summary

Constructors
`SharedServletContextImpl​(javax.servlet.ServletContext webContext, String name, String path, Map<String,​String> initParameters, PerContextHandlerRegistry registry)`

### Method Summary

All Methods Instance Methods Concrete Methods
`javax.servlet.FilterRegistration.Dynamic` `addFilter​(String filterName, Class<? extends javax.servlet.Filter> type)`
`javax.servlet.FilterRegistration.Dynamic` `addFilter​(String filterName, String className)`
`javax.servlet.FilterRegistration.Dynamic` `addFilter​(String filterName, javax.servlet.Filter filter)`
`javax.servlet.ServletRegistration.Dynamic` `addJspFile​(String servletName, String jspFile)`
`void` `addListener​(Class<? extends EventListener> type)`
`void` `addListener​(String className)`
`<T extends EventListener> void` `addListener​(T listener)`
`javax.servlet.ServletRegistration.Dynamic` `addServlet​(String servletName, Class<? extends javax.servlet.Servlet> type)`
`javax.servlet.ServletRegistration.Dynamic` `addServlet​(String servletName, String className)`
`javax.servlet.ServletRegistration.Dynamic` `addServlet​(String servletName, javax.servlet.Servlet servlet)`
`<T extends javax.servlet.Filter> T` `createFilter​(Class<T> type)`
`<T extends EventListener> T` `createListener​(Class<T> type)`
`<T extends javax.servlet.Servlet> T` `createServlet​(Class<T> type)`
`void` `declareRoles​(String... roleNames)`
`Object` `getAttribute​(String name)`
`Enumeration<String>` `getAttributeNames()`
`ClassLoader` `getClassLoader()`
`javax.servlet.ServletContext` `getContext​(String uri)`
`String` `getContextPath()`
`Set<javax.servlet.SessionTrackingMode>` `getDefaultSessionTrackingModes()`
`int` `getEffectiveMajorVersion()`
`int` `getEffectiveMinorVersion()`
`Set<javax.servlet.SessionTrackingMode>` `getEffectiveSessionTrackingModes()`
`javax.servlet.FilterRegistration` `getFilterRegistration​(String filterName)`
`Map<String,​? extends javax.servlet.FilterRegistration>` `getFilterRegistrations()`
`String` `getInitParameter​(String name)`
`Enumeration<String>` `getInitParameterNames()`
`javax.servlet.descriptor.JspConfigDescriptor` `getJspConfigDescriptor()`
`int` `getMajorVersion()`
`String` `getMimeType​(String file)`
`int` `getMinorVersion()`
`javax.servlet.RequestDispatcher` `getNamedDispatcher​(String name)`
`String` `getRealPath​(String path)`
`String` `getRequestCharacterEncoding()`
`javax.servlet.RequestDispatcher` `getRequestDispatcher​(String path)`
`URL` `getResource​(String path)`
`InputStream` `getResourceAsStream​(String path)`
`Set<String>` `getResourcePaths​(String path)`
`String` `getResponseCharacterEncoding()`
`String` `getServerInfo()`
`javax.servlet.Servlet` `getServlet​(String name)`
`String` `getServletContextName()`
`Enumeration<String>` `getServletNames()`
`javax.servlet.ServletRegistration` `getServletRegistration​(String servletName)`
`Map<String,​? extends javax.servlet.ServletRegistration>` `getServletRegistrations()`
`Enumeration<javax.servlet.Servlet>` `getServlets()`
`javax.servlet.SessionCookieConfig` `getSessionCookieConfig()`
`int` `getSessionTimeout()`
`String` `getVirtualServerName()`
`void` `log​(Exception cause, String message)`
`void` `log​(String message)`
`void` `log​(String message, Throwable cause)`
`void` `removeAttribute​(String name)`
`void` `setAttribute​(String name, Object value)`
`boolean` `setInitParameter​(String name, String value)`
`void` `setRequestCharacterEncoding​(String encoding)`
`void` `setResponseCharacterEncoding​(String encoding)`
`void` `setSessionTimeout​(int sessionTimeout)`
`void` `setSessionTrackingModes​(Set<javax.servlet.SessionTrackingMode> modes)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### SharedServletContextImpl

    public SharedServletContextImpl​(javax.servlet.ServletContext webContext,
                                    String name,
                                    String path,
                                    Map<String,​String> initParameters,
                                    PerContextHandlerRegistry registry)

### Method Detail

#### getClassLoader

    public ClassLoader getClassLoader()

Specified by:
  `getClassLoader` in interface `javax.servlet.ServletContext`

#### getResource

    public URL getResource​(String path)

Specified by:
  `getResource` in interface `javax.servlet.ServletContext`
See Also:
  `ServletContext.getResource(java.lang.String)`

#### getMimeType

    public String getMimeType​(String file)

Specified by:
  `getMimeType` in interface `javax.servlet.ServletContext`

#### getRealPath

    public String getRealPath​(String path)

Specified by:
  `getRealPath` in interface `javax.servlet.ServletContext`

#### getResourcePaths

    public Set<String> getResourcePaths​(String path)

Specified by:
  `getResourcePaths` in interface `javax.servlet.ServletContext`

#### addFilter

    public javax.servlet.FilterRegistration.Dynamic addFilter​(String filterName,
                                                              Class<? extends javax.servlet.Filter> type)

Specified by:
  `addFilter` in interface `javax.servlet.ServletContext`

#### addFilter

    public javax.servlet.FilterRegistration.Dynamic addFilter​(String filterName,
                                                              javax.servlet.Filter filter)

Specified by:
  `addFilter` in interface `javax.servlet.ServletContext`

#### addFilter

    public javax.servlet.FilterRegistration.Dynamic addFilter​(String filterName,
                                                              String className)

Specified by:
  `addFilter` in interface `javax.servlet.ServletContext`

#### addListener

    public void addListener​(Class<? extends EventListener> type)

Specified by:
  `addListener` in interface `javax.servlet.ServletContext`

#### addListener

    public void addListener​(String className)

Specified by:
  `addListener` in interface `javax.servlet.ServletContext`

#### addListener

    public <T extends EventListener> void addListener​(T listener)

Specified by:
  `addListener` in interface `javax.servlet.ServletContext`

#### addServlet

    public javax.servlet.ServletRegistration.Dynamic addServlet​(String servletName,
                                                                Class<? extends javax.servlet.Servlet> type)

Specified by:
  `addServlet` in interface `javax.servlet.ServletContext`

#### addServlet

    public javax.servlet.ServletRegistration.Dynamic addServlet​(String servletName,
                                                                javax.servlet.Servlet servlet)

Specified by:
  `addServlet` in interface `javax.servlet.ServletContext`

#### addServlet

    public javax.servlet.ServletRegistration.Dynamic addServlet​(String servletName,
                                                                String className)

Specified by:
  `addServlet` in interface `javax.servlet.ServletContext`

#### createFilter

    public <T extends javax.servlet.Filter> T createFilter​(Class<T> type)
                                                    throws javax.servlet.ServletException

Specified by:
  `createFilter` in interface `javax.servlet.ServletContext`
Throws:
  `javax.servlet.ServletException`

#### createListener

    public <T extends EventListener> T createListener​(Class<T> type)
                                               throws javax.servlet.ServletException

Specified by:
  `createListener` in interface `javax.servlet.ServletContext`
Throws:
  `javax.servlet.ServletException`

#### createServlet

    public <T extends javax.servlet.Servlet> T createServlet​(Class<T> type)
                                                      throws javax.servlet.ServletException

Specified by:
  `createServlet` in interface `javax.servlet.ServletContext`
Throws:
  `javax.servlet.ServletException`

#### declareRoles

    public void declareRoles​(String... roleNames)

Specified by:
  `declareRoles` in interface `javax.servlet.ServletContext`

#### getVirtualServerName

    public String getVirtualServerName()

Specified by:
  `getVirtualServerName` in interface `javax.servlet.ServletContext`

#### getAttribute

    public Object getAttribute​(String name)

Specified by:
  `getAttribute` in interface `javax.servlet.ServletContext`

#### getAttributeNames

    public Enumeration<String> getAttributeNames()

Specified by:
  `getAttributeNames` in interface `javax.servlet.ServletContext`

#### getContext

    public javax.servlet.ServletContext getContext​(String uri)

Specified by:
  `getContext` in interface `javax.servlet.ServletContext`

#### getContextPath

    public String getContextPath()

Specified by:
  `getContextPath` in interface `javax.servlet.ServletContext`

#### getDefaultSessionTrackingModes

    public Set<javax.servlet.SessionTrackingMode> getDefaultSessionTrackingModes()

Specified by:
  `getDefaultSessionTrackingModes` in interface `javax.servlet.ServletContext`

#### getEffectiveMajorVersion

    public int getEffectiveMajorVersion()

Specified by:
  `getEffectiveMajorVersion` in interface `javax.servlet.ServletContext`

#### getEffectiveMinorVersion

    public int getEffectiveMinorVersion()

Specified by:
  `getEffectiveMinorVersion` in interface `javax.servlet.ServletContext`

#### getEffectiveSessionTrackingModes

    public Set<javax.servlet.SessionTrackingMode> getEffectiveSessionTrackingModes()

Specified by:
  `getEffectiveSessionTrackingModes` in interface `javax.servlet.ServletContext`

#### getFilterRegistration

    public javax.servlet.FilterRegistration getFilterRegistration​(String filterName)

Specified by:
  `getFilterRegistration` in interface `javax.servlet.ServletContext`

#### getFilterRegistrations

    public Map<String,​? extends javax.servlet.FilterRegistration> getFilterRegistrations()

Specified by:
  `getFilterRegistrations` in interface `javax.servlet.ServletContext`

#### getInitParameter

    public String getInitParameter​(String name)

Specified by:
  `getInitParameter` in interface `javax.servlet.ServletContext`

#### getInitParameterNames

    public Enumeration<String> getInitParameterNames()

Specified by:
  `getInitParameterNames` in interface `javax.servlet.ServletContext`

#### getJspConfigDescriptor

    public javax.servlet.descriptor.JspConfigDescriptor getJspConfigDescriptor()

Specified by:
  `getJspConfigDescriptor` in interface `javax.servlet.ServletContext`

#### getMajorVersion

    public int getMajorVersion()

Specified by:
  `getMajorVersion` in interface `javax.servlet.ServletContext`

#### getMinorVersion

    public int getMinorVersion()

Specified by:
  `getMinorVersion` in interface `javax.servlet.ServletContext`

#### getNamedDispatcher

    public javax.servlet.RequestDispatcher getNamedDispatcher​(String name)

Specified by:
  `getNamedDispatcher` in interface `javax.servlet.ServletContext`

#### getRequestDispatcher

    public javax.servlet.RequestDispatcher getRequestDispatcher​(String path)

Specified by:
  `getRequestDispatcher` in interface `javax.servlet.ServletContext`

#### getResourceAsStream

    public InputStream getResourceAsStream​(String path)

Specified by:
  `getResourceAsStream` in interface `javax.servlet.ServletContext`

#### getServerInfo

    public String getServerInfo()

Specified by:
  `getServerInfo` in interface `javax.servlet.ServletContext`

#### getServlet

    public javax.servlet.Servlet getServlet​(String name)
                                     throws javax.servlet.ServletException

Specified by:
  `getServlet` in interface `javax.servlet.ServletContext`
Throws:
  `javax.servlet.ServletException`

#### getServletContextName

    public String getServletContextName()

Specified by:
  `getServletContextName` in interface `javax.servlet.ServletContext`

#### getServletNames

    public Enumeration<String> getServletNames()

Specified by:
  `getServletNames` in interface `javax.servlet.ServletContext`

#### getServletRegistration

    public javax.servlet.ServletRegistration getServletRegistration​(String servletName)

Specified by:
  `getServletRegistration` in interface `javax.servlet.ServletContext`

#### getServletRegistrations

    public Map<String,​? extends javax.servlet.ServletRegistration> getServletRegistrations()

Specified by:
  `getServletRegistrations` in interface `javax.servlet.ServletContext`

#### getServlets

    public Enumeration<javax.servlet.Servlet> getServlets()

Specified by:
  `getServlets` in interface `javax.servlet.ServletContext`

#### getSessionCookieConfig

    public javax.servlet.SessionCookieConfig getSessionCookieConfig()

Specified by:
  `getSessionCookieConfig` in interface `javax.servlet.ServletContext`

#### log

    public void log​(Exception cause,
                    String message)

Specified by:
  `log` in interface `javax.servlet.ServletContext`

#### log

    public void log​(String message)

Specified by:
  `log` in interface `javax.servlet.ServletContext`

#### log

    public void log​(String message,
                    Throwable cause)

Specified by:
  `log` in interface `javax.servlet.ServletContext`

#### removeAttribute

    public void removeAttribute​(String name)

Specified by:
  `removeAttribute` in interface `javax.servlet.ServletContext`

#### setAttribute

    public void setAttribute​(String name,
                             Object value)

Specified by:
  `setAttribute` in interface `javax.servlet.ServletContext`

#### setInitParameter

    public boolean setInitParameter​(String name,
                                    String value)

Specified by:
  `setInitParameter` in interface `javax.servlet.ServletContext`

#### setSessionTrackingModes

    public void setSessionTrackingModes​(Set<javax.servlet.SessionTrackingMode> modes)

Specified by:
  `setSessionTrackingModes` in interface `javax.servlet.ServletContext`

#### addJspFile

    public javax.servlet.ServletRegistration.Dynamic addJspFile​(String servletName,
                                                                String jspFile)

Specified by:
  `addJspFile` in interface `javax.servlet.ServletContext`

#### getSessionTimeout

    public int getSessionTimeout()

Specified by:
  `getSessionTimeout` in interface `javax.servlet.ServletContext`

#### setSessionTimeout

    public void setSessionTimeout​(int sessionTimeout)

Specified by:
  `setSessionTimeout` in interface `javax.servlet.ServletContext`

#### getRequestCharacterEncoding

    public String getRequestCharacterEncoding()

Specified by:
  `getRequestCharacterEncoding` in interface `javax.servlet.ServletContext`

#### setRequestCharacterEncoding

    public void setRequestCharacterEncoding​(String encoding)

Specified by:
  `setRequestCharacterEncoding` in interface `javax.servlet.ServletContext`

#### getResponseCharacterEncoding

    public String getResponseCharacterEncoding()

Specified by:
  `getResponseCharacterEncoding` in interface `javax.servlet.ServletContext`

#### setResponseCharacterEncoding

    public void setResponseCharacterEncoding​(String encoding)

Specified by:
  `setResponseCharacterEncoding` in interface `javax.servlet.ServletContext`